diff --git a/Network/Wai.hs b/Network/Wai.hs
index 626b30d..8189592 100644
--- a/Network/Wai.hs
+++ b/Network/Wai.hs
@@ -1,6 +1,7 @@
 {-# LANGUAGE Rank2Types #-}
 {-# LANGUAGE ExistentialQuantification #-}
 {-# LANGUAGE DeriveDataTypeable #-}
+{-# LANGUAGE CPP #-}
 {-|
 
 This module defines a generic web application interface. It is a common
@@ -61,7 +62,11 @@ import qualified Network.HTTP.Types as H
 import Data.Text (Text)
 import Data.ByteString.Lazy.Char8 () -- makes it easier to use responseLBS
 import Blaze.ByteString.Builder (fromByteString)
+#if MIN_VERSION_vault(0,3,0)
+import Data.Vault.Lazy (Vault)
+#else
 import Data.Vault (Vault)
+#endif
 import Data.Word (Word64)
 
 -- | Information on the request sent by the client. This abstracts away the
